#include <math.h>
int main()
{
    long long int n,x;
    int l,i,j;
    scanf("%lld %d",&n,&l);
    long long int D[l];
    int k=0,z;
    long long int B[n];
    for(i=0;i<l;i++)
    {
        scanf("%lld",&D[i]);

    }
    for(j=0;j<l;j++)
    {
        z=0;
        x=D[i];


     for(i=2;i<sqrt(x);i++)
     {
       if(x%i==0)
       {
           B[k]=i;
           k++;
           x = x/i;
           i=2;
       }
     }

    for(i=0;i<k;i++)
    {
        z = z^B[i];
    }
    printf("%d ",z);
    }
}